## flannel 0.5.5~ds1

=== debian/changelog ===
flannel (0.5.5~ds1-2) unstable; urgency=medium

  * Update patch for recent golang-github-vishvananda-netlink B-D
  * Use https for Vcs-Git URL.

 -- Tim Potter <tpot@hpe.com>  Fri, 10 Feb 2017 15:55:34 +1100

flannel (0.5.5~ds1-1) unstable; urgency=medium

  * Initial release (Closes: #829217)

 -- Tim Potter <tpot@hpe.com>  Fri, 22 Jul 2016 08:05:13 +1000
