=== debian/control ===
Source: flannel
Section: devel
Priority: extra
Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
Uploaders: Tim Potter <tpot@hpe.com>
Build-Depends: debhelper (>=9),
               dh-golang,
               golang-github-coreos-go-iptables-dev,
               golang-github-coreos-go-systemd-dev,
               golang-github-gorilla-context-dev,
               golang-github-gorilla-mux-dev,
               golang-github-vishvananda-netlink-dev,
               golang-github-vishvananda-netns-dev,
               golang-glog-dev,
               golang-go
Standards-Version: 3.9.8
Homepage: https://github.com/coreos/flannel
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-go/packages/flannel.git
Vcs-Git: https://anonscm.debian.org/git/pkg-go/packages/flannel.git
XS-Go-Import-Path: github.com/coreos/flannel

Package: flannel
Architecture: any
Built-Using: ${misc:Built-Using}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Etcd backed network fabric for containers
 Flannel is a virtual network that gives a subnet to each host for
 use with container runtimes.
 .
 Platforms like Google's Kubernetes assume that each container (pod)
 has a unique, routable IP inside the cluster. The advantage of this
 model is that it reduces the complexity of doing port mapping.
