=== debian/watch ===
version=3
opts=repacksuffix=~ds1,dversionmangle=s{[~+](?:ds|dfsg)\d*$}{},repack,compression=xz,filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/flannel-$1\.tar\.gz/ \
  https://github.com/coreos/flannel/tags .*/v?(\d\S*)\.tar\.gz
