## flannel 0.9.1~ds1

=== debian/changelog ===
flannel (0.9.1~ds1-1) unstable; urgency=medium

  * New upstream version.
  * Remove unneeded patches, update d/copyright and d/control for
    move to Glide from Godeps, and large number of new dependencies.

 -- Tim Potter <tpot@hpe.com>  Tue, 21 Nov 2017 15:11:28 +1100
