=== debian/control ===
--- 
+++ 
@@ -1,19 +1,39 @@
 Source: flannel
 Section: devel
-Priority: extra
+Priority: optional
 Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
 Uploaders: Tim Potter <tpot@hpe.com>
 Build-Depends: debhelper (>=9),
                dh-golang,
+               golang-etcd-server-dev,
                golang-github-coreos-go-iptables-dev,
                golang-github-coreos-go-systemd-dev,
-               golang-github-gorilla-context-dev,
-               golang-github-gorilla-mux-dev,
+               golang-github-coreos-pkg-dev,
+               golang-github-davecgh-go-spew-dev,
+               golang-github-denverdino-aliyungo-dev,
+               golang-github-ghodss-yaml-dev,
+               golang-github-go-ini-ini-dev,
+               golang-github-go-openapi-spec-dev,
+               golang-github-gogo-protobuf-dev,
+               golang-github-google-gofuzz-dev,
+               golang-github-howeyc-gopass-dev,
+               golang-github-imdario-mergo-dev,
+               golang-github-jmespath-go-jmespath-dev,
+               golang-github-joho-godotenv-dev,
+               golang-github-jonboulle-clockwork-dev,
+               golang-github-juju-ratelimit-dev,
+               golang-github-spf13-pflag-dev,
+               golang-github-ugorji-go-codec-dev,
                golang-github-vishvananda-netlink-dev,
-               golang-github-vishvananda-netns-dev,
                golang-glog-dev,
-               golang-go
-Standards-Version: 3.9.8
+               golang-go,
+               golang-golang-x-oauth2-google-dev,
+               golang-google-api-dev,
+               golang-google-appengine-dev,
+               golang-google-cloud-compute-metadata-dev,
+               golang-gopkg-inf.v0-dev,
+               golang-gopkg-yaml.v2-dev
+Standards-Version: 4.1.1
 Homepage: https://github.com/coreos/flannel
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-go/packages/flannel.git
 Vcs-Git: https://anonscm.debian.org/git/pkg-go/packages/flannel.git
